#include "global.h"
#ifdef MCF
#define TREE '^'
#define INTREE '%'
#define FTREE '$'
#define BLANK '#'
void GraphOfNetwork::flowCorrection(char *fgfile,int* &Node_current)
{
   int sourceNode=0,sinkNode=0,i=0,j=0;
   char tempStr[80];
   double cost;
   char failed;
   fgedge e;
   edge temp_edge;
   FILE *from;
   int flowSource=0,flowSink=0,mainCurrent=0,current=0,capacity=0;
   from=fopen(fgfile,"r+");
   if(from == NULL)
   {
        cout<<" Flow Circuit File Not Found " <<endl;
        exit(0);
   }
   temp_edge=edgePtrList[0];
   while (fgets(tempStr, 80, from) != NULL)
   {
       switch(tempStr[0])
       {
       case 'p':
         sscanf(tempStr,"p min %d %d",&_Nodes,&_Edges);
         fgNodePtrList = (fgnode*) calloc(_Nodes,sizeof(fgnode));
         fgEdgePtrList = (fgedge*) calloc(_Edges,sizeof(fgedge));
         break;
       case 'n':
         sscanf(tempStr,"n %d %d",&sourceNode,&current);
         --sourceNode;
         if(current > 0)  {flowSource = sourceNode;mainCurrent=current;}
         else if (current < 0) flowSink = sourceNode;
         break;
       case 'V':
         sscanf(tempStr,"V %d %d %d",&sourceNode,&sinkNode,&capacity);
         sourceNode--;
         sinkNode--;
         if(fgNodePtrList[sourceNode] == NULL) fgNodePtrList[sourceNode] = new FGNode(sourceNode);
         if(fgNodePtrList[sinkNode] == NULL) fgNodePtrList[sinkNode] = new FGNode(sinkNode);
         addFgEdge(VoltageSource,fgNodePtrList[sourceNode],fgNodePtrList[sinkNode],temp_edge->EdgeValue,temp_edge->Voltage,capacity,i,BLANK);
         temp_edge=edgePtrList[++j];
         break;
       case 'I':
         sscanf(tempStr,"I %d %d %*d %d %lf",&sourceNode,&sinkNode,&capacity,&cost);
         sourceNode--;
         sinkNode--;
         if(fgNodePtrList[sourceNode] == NULL) fgNodePtrList[sourceNode] = new FGNode(sourceNode);
         if(fgNodePtrList[sinkNode] == NULL) fgNodePtrList[sinkNode] = new FGNode(sinkNode);
         addFgEdge(CurrentSource,fgNodePtrList[sourceNode],fgNodePtrList[sinkNode],cost,temp_edge->EdgeValue,capacity,i,BLANK);
         temp_edge=edgePtrList[++j];
         break;
       case 'a':
         if(capacity>mainCurrent)
		capacity=mainCurrent; 
         sscanf(tempStr,"a %d %d %*d %d %lf",&sourceNode,&sinkNode,&capacity,&cost);
         sourceNode--;
         sinkNode--;
 	 if(fgNodePtrList[sourceNode] == NULL) fgNodePtrList[sourceNode] = new FGNode(sourceNode);
         if(fgNodePtrList[sinkNode] == NULL) fgNodePtrList[sinkNode] = new FGNode(sinkNode);
         if(edgePtrList[j+1]->devCharNotSatisfied ||edgePtrList[j+3]->devCharNotSatisfied)
		failed=false;
         else
		failed=BLANK;
         addFgEdge(FlowEdge,fgNodePtrList[sourceNode],fgNodePtrList[sinkNode],cost,temp_edge->EdgeValue,capacity,i,failed);
         j+=6;
         temp_edge=edgePtrList[j];
         break;
       case 'c' :
         break;
       default : cout <<"File doesn't looks to be in DIMACS format " << endl;exit(0);
       }
  }
  fclose(from);
  free(edgePtrList);
  
  fgnode firstFGNode=fgNodePtrList[0];  
  fgnode n;
  int* nodeBlock = (int*) calloc(_Nodes,sizeof(int));
  bool* nodeCovered = (bool*) calloc(_Nodes,sizeof(bool));
  int _Blocks=1; 
  int counter=1;
  double diff_scale=0;
  if(scalecapacity-scalecost>0)
       diff_scale=scalecapacity-scalecost;

  for(int i=0;e=fgEdgePtrList[i],i<_Edges;++i)
     if(!e->isEdgeType(CurrentSource))
       if(e->EdgeValue>0.8 && e->EdgeValue<(scalecapacity/100)&& ((e->EdgeValue<e->Capacity-0.5)||(e->EdgeValue<sqrt(diff_scale))))
            e->edgeCovered=false;
  
  _Blocks=buildTreeOfA(nodeCovered,nodeBlock);
  
  for(int i=0;e=fgEdgePtrList[i],i<_Edges;++i)
     if(!e->isEdgeType(CurrentSource)&&e->edgeCovered!=TREE)
       if(e->EdgeValue>=(scalecapacity/100) && ((e->EdgeValue<e->Capacity-0.5)||(e->EdgeValue<sqrt(diff_scale))))
        	e->edgeCovered=false;
   
  extendTreeOfA(nodeCovered,nodeBlock,_Blocks);
  extendTreeOfACompleteGraph(nodeCovered,nodeBlock,_Blocks);
   
  int count=0;
  for(int i=0;e=fgEdgePtrList[i],i<_Edges;++i)
  	if(e->edgeCovered==TREE) ++count;
//  cout<<"Tree edge : "<<count<<endl;
  
  if(mainCurrent!=0){
     Node_current[flowSource]=-mainCurrent;
     Node_current[flowSink]=mainCurrent;
  }
  int _FCotreeEdges=assignIntFlow();
//  cout<<"Number of Faulty Cotree Edges: "<<_FCotreeEdges<<endl;
  if(_FCotreeEdges<10 ||_FCotreeEdges<(_Nodes/1000)){
     while(1){
       findFlow(Node_current);  
       int _FEdges=0;
       for(int i=0;e=fgEdgePtrList[i],i<_Edges;++i){
          if(e->EdgeValue>e->Capacity || e->EdgeValue<0){
             if(e->EdgeValue>e->Capacity)
          	e->EdgeValue=e->Capacity;
             else
          	e->EdgeValue=0;
             ++_FEdges;
             e->edgeCovered=true;
          }
          else if(e->edgeCovered==INTREE)
             e->edgeCovered=false;
       }
       if(_FEdges){
          cout<<"Error: Flow Value is not satisfied for "<<_FEdges<<" Edges."<<endl;
          for(int i=0;n=fgNodePtrList[i],i<_Nodes;++i){
          	nodeCovered[n->nodeNumber]=false;
          	nodeBlock[n->nodeNumber]=0;
          }
          _Blocks=buildTreeOfA(nodeCovered,nodeBlock);
          
          for(int i=0; i<_Edges;++i){
             e=fgEdgePtrList[i];	
             if(e->edgeCovered!=true && e->edgeCovered!=TREE)
          	e->edgeCovered=false;
          }
          extendTreeOfA(nodeCovered,nodeBlock,_Blocks);   
          extendTreeOfACompleteGraph(nodeCovered,nodeBlock,_Blocks);	
          
          count=0;
          for(int i=0;e=fgEdgePtrList[i],i<_Edges;++i)
          	if(e->edgeCovered==TREE) ++count;
          cout<<"Tree edge : "<<count<<endl;

          if(mainCurrent!=0){
             Node_current[flowSource]=-mainCurrent;
       	     Node_current[flowSink]=mainCurrent;
          }
          _FCotreeEdges=assignIntFlow();
       }
       else
          break; 
    }    
  }
  else{
   //  clock_t loop_time=clock(); 
      fgedge back_e=NULL;
      fgnode predecessor,successor;
      bool* nodeCovered1 = (bool*) calloc(_Nodes,sizeof(bool));
      bool flag=false,treeEdgeFound=false;
      stack <fgnode> stackOfNodes;
      n=firstFGNode;
      stackOfNodes.push(n);
      nodeCovered1[n->nodeNumber]=true;
      while(!stackOfNodes.empty())
      {
         predecessor=stackOfNodes.top();
         treeEdgeFound=false;
         forall_adj_fgedges(e,predecessor)
         {
            flag=false;
            if(e->edgeCovered==TREE)
            {
               treeEdgeFound=true;
               back_e=e;
               n=other_node(e,predecessor);
               if(nodeCovered1[n->nodeNumber]==true)
                   continue;
               successor=n;
               nodeCovered1[successor->nodeNumber]=true;
               stackOfNodes.push(successor);
               flag=true;
               break;
            }
         }
         if(flag==false)
         {
           forall_adj_fgedges(e,predecessor)
             if(e->edgeCovered!=TREE && e->edgeCovered!=INTREE){
	       if(e->edgeCovered!=false && e->edgeCovered!=FTREE){
                  if(predecessor==e->Source)
                     Node_current[predecessor->nodeNumber]+=(int)e->EdgeValue;
                  else
                    Node_current[predecessor->nodeNumber]-=(int)e->EdgeValue;
	       }
	       else if(treeEdgeFound)
		  back_e->edgeCovered=FTREE;
             }  
           if(!treeEdgeFound)
           	break;
           if(back_e->edgeCovered!=FTREE){
             if(predecessor==back_e->Source){
                back_e->EdgeValue=-Node_current[predecessor->nodeNumber];
                Node_current[back_e->Sink->nodeNumber]-=(int)back_e->EdgeValue;
                Node_current[back_e->Source->nodeNumber]+=(int)back_e->EdgeValue;
                back_e->edgeCovered=INTREE;
             }	
             else{
                back_e->EdgeValue=Node_current[predecessor->nodeNumber];
                Node_current[back_e->Source->nodeNumber]+=(int)back_e->EdgeValue;
                Node_current[back_e->Sink->nodeNumber]-=(int)back_e->EdgeValue;
                back_e->edgeCovered=INTREE;
             }
           } 
           stackOfNodes.pop();
         }
     }
     free(nodeCovered1); 
     n=firstFGNode;
     while(1)
     {
        counter=-1;
        forall_adj_fgedges(e,n)
        {
           if(e->edgeCovered==FTREE||e->edgeCovered==false){
               ++counter;
               back_e=e;
           }
        } 
        if(!counter){
             if(n==back_e->Source){
                back_e->EdgeValue=-Node_current[n->nodeNumber];
                Node_current[back_e->Sink->nodeNumber]-=(int)back_e->EdgeValue;
                Node_current[back_e->Source->nodeNumber]+=(int)back_e->EdgeValue;
                back_e->edgeCovered=INTREE;
             }
             else{
                back_e->EdgeValue=Node_current[n->nodeNumber];
                Node_current[back_e->Source->nodeNumber]+=(int)back_e->EdgeValue;
                Node_current[back_e->Sink->nodeNumber]-=(int)back_e->EdgeValue;
                back_e->edgeCovered=INTREE;
             }
        }
        else
           break;
         n=other_node(back_e,n);
     }
  // cout<<"Loop time: "<<double(clock()-loop_time)/CLOCKS_PER_SEC<<endl;
   }
   free(nodeCovered);
   free(nodeBlock);
}

void GraphOfNetwork::addFgEdge(char Type,fgnode Source,fgnode Sink,double depValue,double Value,int cap,int& i,char status)
{
  fgEdgePtrList[i] = new FGEdge(Value,Type,Source,Sink);
  if(Type==VoltageSource)
        fgEdgePtrList[i]->EdgeValue=depValue;
  else
        fgEdgePtrList[i]->Voltage=depValue;
  fgEdgePtrList[i]->Capacity=cap;
  fgEdgePtrList[i]->edgeCovered=status;
  Source->addEdgeList(fgEdgePtrList[i]);
  Sink->addEdgeList(fgEdgePtrList[i]);
  ++i;
}

int GraphOfNetwork::assignIntFlow(void)
{
  int _FCotreeEdges=0;
  fgedge e;
  for(int i=0;e=fgEdgePtrList[i],i<_Edges;++i){
    if(e->edgeCovered!=TREE && e->EdgeType!=CurrentSource){
        if(e->edgeCovered==false){
            ++_FCotreeEdges;
            if(fabs(e->EdgeValue-round(e->EdgeValue))<0.2)
                e->EdgeValue=round(e->EdgeValue);
            else
                e->EdgeValue=trunc(e->EdgeValue);
         }
         else if(e->EdgeValue<0.8){
                e->EdgeValue=trunc(e->EdgeValue);
		e->edgeCovered=true;
	 }
         else
                e->EdgeValue=round(e->EdgeValue);
         if(e->EdgeValue>e->Capacity){
                e->EdgeValue=e->Capacity;
	 	e->edgeCovered=true;
         }
         if(e->EdgeValue<0){
                e->EdgeValue=0.0;
		e->edgeCovered=true;
 	 }
    }
    if(e->EdgeType==CurrentSource)
        e->EdgeValue=round(e->EdgeValue);
  }
  return _FCotreeEdges;
}

int GraphOfNetwork::buildTreeOfA(bool* &nodeCovered,int* &nodeBlock)
{
  queue<fgnode> queueOfNodes;
  fgnode n1,n2,startNode;
  fgedge e;
  int _Blocks=1;
  bool treeEdgeFound=false;
  for(int i=0;startNode=fgNodePtrList[i],i<_Nodes;++i)
  {
     if(nodeCovered[startNode->nodeNumber]==true) continue;
     if(startNode->edgeList.empty()) continue;
     queueOfNodes.push(startNode);
     treeEdgeFound=false;
   //This part builds tree of edges(not forest)
     while(!queueOfNodes.empty())
     {
       n1=queueOfNodes.front();
       forall_adj_fgedges(e,n1)
       {
        n2= other_node(e,n1);
        if(n1==n2) continue;
        if(e->edgeCovered==false && e->EdgeType!=CurrentSource)
          if(!nodeCovered[n2->nodeNumber])
          {
            e->edgeCovered = TREE;
            nodeCovered[n2->nodeNumber]=true;
            nodeBlock[n2->nodeNumber] = _Blocks;
            treeEdgeFound=true;
            queueOfNodes.push(n2);
          }
       }
       queueOfNodes.pop();
     }
     if(treeEdgeFound)
     {
       nodeCovered[startNode->nodeNumber] =true;
       nodeBlock[startNode->nodeNumber] = _Blocks;
       ++_Blocks;
     }
  }
  return _Blocks;
}

void GraphOfNetwork::extendTreeOfA(bool* &nodeCovered,int* &nodeBlock, int &_Blocks)
{
  int block1,block2;
  fgnode n1,n2;
  fgedge e;
  list<int> tree_counter[_Nodes];
  bool connectedBlockFound;
  for(int i=0; i<_Edges;++i)
  {
    e=fgEdgePtrList[i];
    if(e->edgeCovered==false){
     n1=e->Source;
     n2=e->Sink;
     if(n1 == n2) continue;
     if(!nodeCovered[n2->nodeNumber] &&!nodeCovered[n1->nodeNumber]){
     	e->edgeCovered = TREE;
     	nodeBlock[n2->nodeNumber]=_Blocks;
     	nodeBlock[n1->nodeNumber]=_Blocks;
     	nodeCovered[n1->nodeNumber] =true;
     	nodeCovered[n2->nodeNumber] =true;
     	++_Blocks;
     	continue;
      }
      if(!nodeCovered[n2->nodeNumber]){
     	e->edgeCovered = TREE;
     	nodeBlock[n2->nodeNumber]=nodeBlock[n1->nodeNumber];
     	nodeCovered[n2->nodeNumber] =true;
     	continue;
      }
      if(!nodeCovered[n1->nodeNumber]){
     	e->edgeCovered = TREE;
     	nodeBlock[n1->nodeNumber]=nodeBlock[n2->nodeNumber];
     	nodeCovered[n1->nodeNumber] =true;
     	continue;
      }
      if(nodeBlock[n2->nodeNumber]!=nodeBlock[n1->nodeNumber]){
     	connectedBlockFound=false;
     	block1=nodeBlock[n2->nodeNumber]<nodeBlock[n1->nodeNumber]? nodeBlock[n2->nodeNumber]:nodeBlock[n1->nodeNumber];
     	block2=nodeBlock[n2->nodeNumber]<nodeBlock[n1->nodeNumber]? nodeBlock[n1->nodeNumber]:nodeBlock[n2->nodeNumber];
        list<int> :: iterator p;
     	while(!tree_counter[block2].empty()){   
           p=tree_counter[block2].begin();
     	   if(*p==0)
     	     if(block1<*(++p))
     	    	block2=*p;
     	     else{
     		block2=block1;
     		block1=*p;
     	     }
           else
     	     break;
     	}   	 
     	while(!tree_counter[block1].empty()){
            p=tree_counter[block1].begin();
            if(*p==0)
                 block1=*(++p);
            else
                 break;
        }
     	for(p=tree_counter[block1].begin(); p!=tree_counter[block1].end(); ++p)
       	   if(*p==block2){
            	connectedBlockFound =true;
          	break;
       	   }
        if(block2==1 || block1==block2)
           continue; 
     	if(!connectedBlockFound){
       	   e->edgeCovered = TREE;
       	   connectedBlockFound=false;
       	   if(!tree_counter[block2].empty())
            	tree_counter[block1].merge(tree_counter[block2]);
       	   else
            	tree_counter[block1].push_back(block2);
     	   tree_counter[block2].push_back(0);
     	   tree_counter[block2].push_back(block1);
       	   continue;
     	}
      }
    }
  }
  for(int i=0;i<_Nodes;++i){
     n1=fgNodePtrList[i];
     if(nodeCovered[n1->nodeNumber]){
        block1=nodeBlock[n1->nodeNumber];
        list<int> :: iterator p;
        for(p=tree_counter[block1].begin(); p!=tree_counter[block1].end();){
           if(*p==0){
              block1=*(++p);
              p=tree_counter[block1].begin();
              continue;
           }
	   ++p;
        }
        if(nodeBlock[n1->nodeNumber]!=block1){
        	nodeBlock[n1->nodeNumber]=block1;
        }
     }
  }	
}

void GraphOfNetwork::extendTreeOfACompleteGraph(bool* &nodeCovered,int* &nodeBlock,int &_Blocks)
{
  fgnode n1,n2;
  fgedge e;
  int block1,block2;
  bool connectedBlockFound=false;
  list<int> tree_counter[_Nodes];
  for(int i=0; i<_Edges;++i)
  {
    e=fgEdgePtrList[i];
    if(e->edgeCovered==TREE || e->EdgeType==CurrentSource)
  	continue;
    n1=e->Source;
    n2=e->Sink;
    if(n1 == n2) continue;
    if(!nodeCovered[n2->nodeNumber] &&!nodeCovered[n1->nodeNumber]){
    	e->edgeCovered = TREE;
    	nodeBlock[n2->nodeNumber]=_Blocks;
    	nodeBlock[n1->nodeNumber]=_Blocks;
    	nodeCovered[n1->nodeNumber] =true;
    	nodeCovered[n2->nodeNumber] =true;
    	++_Blocks;
    	continue;
    }
    if(!nodeCovered[n2->nodeNumber]){
    	e->edgeCovered = TREE;
    	nodeBlock[n2->nodeNumber]=nodeBlock[n1->nodeNumber];
    	nodeCovered[n2->nodeNumber] =true;
    	continue;
    }
    if(!nodeCovered[n1->nodeNumber]){
    	e->edgeCovered = TREE;
    	nodeBlock[n1->nodeNumber]=nodeBlock[n2->nodeNumber];
    	nodeCovered[n1->nodeNumber] =true;
    	continue;
    }
    if(nodeBlock[n2->nodeNumber]!=nodeBlock[n1->nodeNumber]){
    	connectedBlockFound=false;
    	block1=nodeBlock[n2->nodeNumber]<nodeBlock[n1->nodeNumber]? nodeBlock[n2->nodeNumber]:nodeBlock[n1->nodeNumber];
    	block2=nodeBlock[n2->nodeNumber]<nodeBlock[n1->nodeNumber]? nodeBlock[n1->nodeNumber]:nodeBlock[n2->nodeNumber];
        list<int> :: iterator p;
    	while(!tree_counter[block2].empty()){   
           p=tree_counter[block2].begin();
    	   if(*p==0)
    	     if(block1<*(++p))
    	    	block2=*p;
    	     else{
    		block2=block1;
    		block1=*p;
    	     }
           else
    	     break;
    	}   	 
    	while(!tree_counter[block1].empty()){
           p=tree_counter[block1].begin();
           if(*p==0)
                block1=*(++p);
           else
                break;
        }
    	for(p=tree_counter[block1].begin(); p!=tree_counter[block1].end(); ++p)
      	   if(*p==block2){
           	connectedBlockFound =true;
         	break;
      	   }
        if(block2==1 || block1==block2)
	   continue; 
    	if(!connectedBlockFound){
      	   e->edgeCovered = TREE;
      	   connectedBlockFound=false;
      	   if(!tree_counter[block2].empty())
           	tree_counter[block1].merge(tree_counter[block2]);
      	   else
           	tree_counter[block1].push_back(block2);
    	   tree_counter[block2].push_back(0);
    	   tree_counter[block2].push_back(block1);
      	   continue;
    	}
     }
  }
}

void GraphOfNetwork::findFlow(int* &Node_current)
{
  int counter=0;
  bool flag=false,treeEdgeFound;
  fgnode n;
  fgedge e,back_e=NULL;
  fgnode predecessor,successor;
  bool* nodeCovered = (bool*) calloc(_Nodes,sizeof(bool));
  stack <fgnode> stackOfNodes;
  fgnode startNode=fgNodePtrList[0];
  stackOfNodes.push(startNode);
  nodeCovered[startNode->nodeNumber]=true;
  while(!stackOfNodes.empty())
  {
      predecessor=stackOfNodes.top();
      treeEdgeFound=false;
      forall_adj_fgedges(e,predecessor)
      {
         flag=false;
         if(e->edgeCovered==TREE)
         {
            treeEdgeFound=true;
            back_e=e;
            n=other_node(e,predecessor);
            if(nodeCovered[n->nodeNumber]==true)
                continue;
            successor=n;
            nodeCovered[successor->nodeNumber]=true;
            stackOfNodes.push(successor);
            flag=true;
            break;
         }
      }
      if(flag==false)
      {
        forall_adj_fgedges(e,predecessor)
          if(e->edgeCovered!=TREE && e->edgeCovered!=INTREE)
            if(predecessor==e->Source)
                 Node_current[predecessor->nodeNumber]+=(int)e->EdgeValue;
            else
                 Node_current[predecessor->nodeNumber]-=(int)e->EdgeValue;
        if(!treeEdgeFound)   //for root node only
             break;
        if(predecessor==back_e->Source){
           back_e->EdgeValue=-Node_current[predecessor->nodeNumber];
           Node_current[back_e->Sink->nodeNumber]-=(int)back_e->EdgeValue;
           Node_current[back_e->Source->nodeNumber]+=(int)back_e->EdgeValue;
           back_e->edgeCovered=INTREE;
        }
        else{
           back_e->EdgeValue=Node_current[predecessor->nodeNumber];
           Node_current[back_e->Source->nodeNumber]+=(int)back_e->EdgeValue;
           Node_current[back_e->Sink->nodeNumber]-=(int)back_e->EdgeValue;
           back_e->edgeCovered=INTREE;
        }
        stackOfNodes.pop();
      }
  } 
  free(nodeCovered);
  cout<<"After Rounding:"<<endl;
  counter=0;
  for(int i=0;i<_Nodes;++i)
     if(Node_current[i]!=0){
        ++counter;
     } 	
  if(counter)
     cout<<"Error: Flow Conservation Property is not satisfied for "<<counter<<" Nodes."<<endl;
}
#endif

