#include "global.h"
int main (int argc, char **argv)
{
	clock_t init_time = clock ();
	GraphOfNetwork G;
	cout << endl;
	cout << endl;
	cout << "***************************************************************************************************" << endl;
	cout << "***************************************************************************************************" << endl;
	cout << endl;
	cout << "Copyright (c) 2004-2011 Department of Electrical Engineering, Indian Institute of Technology Bombay (IIT Bombay), "<< endl;
	cout << "Powai, Mumbai, India, Pin 400076.  All rights reserved." << endl;
	cout << "Author: 2007-2010 Dr. Gaurav Trivedi, Yogesh Dilip Save" << endl;
	cout << endl;
	cout << "***************************************************************************************************" << endl;
	cout << "***************************************************************************************************" << endl;
	cout << "This is the combinatorial optimization solver using electrical network analogy " << endl;
	cout << "developed at EE Department, IIT Bombay, Powai, Mumbai-76. " << endl;
	cout << "For any bug encountered in executing this software, please contact "<<endl;
	cout << endl;
	cout << "Dr. Gaurav Trivedi (trivedi@ee.iitb.ac.in), " << endl;
	cout << "Yogesh Dilip Save (syogesh@ee.iitb.ac.in), " << endl;
	cout << "Dr. Sachin B. Patkar (patkar@ee.iitb.ac.in) and "<< endl;
	cout << "Dr. H. Narayanan (hn@ee.iitb.ac.in)." <<endl;
	cout << endl;
	cout << "***************************************************************************************************" << endl;
	cout << "***************************************************************************************************" << endl;
	cout << endl;
//	cout << "Note : This  software is distributed for the use of academic purpose only. It may not be distributed or used " <<endl;
//	cout << "commercially without the explicit permission of the copyright holders.    " << endl; 
//	cout << endl;
//	cout << "***************************************************************************************************" << endl;
//	cout << "***************************************************************************************************" << endl;
//	cout << endl;
	cout << endl;

#ifdef DCANA
	if (argc != 2) { 
		cerr << "Usage :" << argv[0] << " circuitFile.spice" << endl;
		exit (1);
	}
	G.convertCircuitIntoGraph (argv[1]);
#endif 
#ifdef MCF 
	if (argc != 3) { 
		cerr << "Usage :" << argv[0] << " DIMACS_FORMAT_PROBLEM scaleParameter"<< endl;
		exit (1);
	}
	G.convertFlowProblemToCircuit(argv[1],atof(argv[2]));
#endif 

	stack<node> voltageTree;
	G.makeG1 ();
	G.makeG2 ();
	G.findG2Voltages (voltageTree);
	G.modifyNodeNumber();
	G.findVoltages(); 
	G.findCurrents();
	G.checkForKCL();
	G.findVoltageBranchCurrents (voltageTree);
	//  double totalPower; 

#ifdef DCANA 
	totalPower = G.printSolution(argv[1]);
#endif 
#ifdef MCF
	G.buildFlowGraph(argv[1]);
	//  G.scaling();
	//  totalPower = G.printSolution(argv[1]);
	//  G.printFlowInfo(argv[1]);
#endif
	cout<<"CombOptSolver : Total Time = "<<double(clock()-init_time)/CLOCKS_PER_SEC<<endl;
	exit(0);
}
