#include "global.h"
nodeMap nodeTable;
int* reverseNodeTable = NULL;
extern double Gval;
#ifdef MCF 
void GraphOfNetwork::convertFlowProblemToCircuit(char*
circuitName,double scaleParameter)
{
  char tempStr[80];
  int sourceNode=0,sinkNode=0,_ExcessNodes=0;
  FILE *from; 
  from=fopen(circuitName,"r+");
  if(from == NULL)
  {
	cout<<" *********Error*********" <<endl;
	cout<<" Flow Circuit File Not Found " <<endl;
	exit(0);
  }
  int i=0; 
  int nodeCost,nodeNumber,psuedoNode=0,capacity=0,cost=0,refNode=0;
  double branchValue;
  int mainCurrent=0,absFlow=0;
  double MAXcost=0.0,MAXcapacity=0.0; 
  while (fgets(tempStr, 80, from) != NULL)
  {
      switch(tempStr[0]){ 
	case 'n':
	  sscanf(tempStr,"n %d %d",&nodeNumber,&nodeCost);
	  if(refNode==0)
		refNode=nodeNumber;
	  else
		++_ExcessNodes;
	  mainCurrent+=nodeCost;
	  absFlow+=abs(nodeCost);	
	case 'p':
	case 'a':
	case 'c':
	case 'I':
	case 'V': 
	  break;
	default: 
	  cout <<"File doesn't looks to be in DIMACS format " << endl;exit(0);
      }
  }	
  fclose(from);
  from=fopen(circuitName,"r+");
  while (fgets(tempStr, 80, from) != NULL)
  {
      switch(tempStr[0]) 
	{
	case 'p':
	  sscanf(tempStr,"p min %d %d %d",&_Nodes,&_Edges,&_SimplifiedEdges);
	  psuedoNode= _Nodes; 
	  nodePtrList = (node*) calloc(_Nodes+2*_Edges-2*_SimplifiedEdges,sizeof(node));
	  edgePtrList = (edge*) calloc (_Edges*6+_ExcessNodes-5*_SimplifiedEdges,sizeof(edge));
          reverseNodeTable=new int[_Nodes+1];
          refNode = assignNodeNumber(refNode);
  	  --refNode;	  	
	  if(nodePtrList[refNode] == NULL) nodePtrList[refNode] = new Node(refNode);
	  break;
	case 'n':
	  sscanf(tempStr,"n %d %d",&nodeNumber,&nodeCost);
	  nodeNumber = assignNodeNumber(nodeNumber);
 	  --nodeNumber;
	  if(nodePtrList[nodeNumber] == NULL) nodePtrList[nodeNumber] = new Node(nodeNumber);
          if(nodeNumber!=refNode)
	     if(nodeCost>0){	
  	  	addEdge(nodeCost,CurrentSource,nodePtrList[refNode],nodePtrList[nodeNumber],i);
		scalecapacity+=nodeCost;
	     }
	     else{
		nodeCost*=-1;
  	  	addEdge(nodeCost,CurrentSource,nodePtrList[nodeNumber],nodePtrList[refNode],i);
		scalecapacity+=nodeCost;
	     }	
	  break;
	case 'a':
	  if(mainCurrent != 0 )
	  {
	   cout << " Error in file or Min Cost flow solution has no solution " << endl; 
	   cout << " Exiting Abnormally !!!!!!!!!!!  " << endl;
	   exit(1); 
	  }
	  sscanf(tempStr,"a %d %d %*d %d %d",&sourceNode,&sinkNode,&capacity,&cost);
	  if(capacity > absFlow)
		capacity=absFlow;
	  scalecapacity += capacity; 
	  scalecost += cost; 
    	  if(MAXcapacity < capacity) MAXcapacity = capacity; 
          if(MAXcost < cost) MAXcost = cost;
	  sourceNode = assignNodeNumber(sourceNode);
          sinkNode = assignNodeNumber(sinkNode); 
	  --sourceNode;--sinkNode;

	  if(nodePtrList[sourceNode] == NULL) nodePtrList[sourceNode] = new Node(sourceNode);
	  if(nodePtrList[sinkNode] == NULL) nodePtrList[sinkNode] = new Node(sinkNode);
	  if(nodePtrList[psuedoNode] == NULL) nodePtrList[psuedoNode] = new Node(psuedoNode);
	  if(nodePtrList[psuedoNode+1] == NULL) nodePtrList[psuedoNode+1] = new Node(psuedoNode+1);
	  
	  addEdge(cost,VoltageSource,nodePtrList[psuedoNode],nodePtrList[sinkNode],i);
	  addDiodeEdge(nodePtrList[sourceNode],nodePtrList[psuedoNode+1],i);
	  addDiodeEdge(nodePtrList[psuedoNode],nodePtrList[psuedoNode+1],i);
	  addEdge(capacity,CurrentSource,nodePtrList[psuedoNode+1],nodePtrList[psuedoNode],i);
	  ++++psuedoNode;
	  break;
        case 'I' :
	  cost=0;
	  sscanf(tempStr,"I %d %d %lf %*d %d",&sourceNode,&sinkNode,&branchValue,&cost);
	  sourceNode = assignNodeNumber(sourceNode);
          sinkNode = assignNodeNumber(sinkNode); 
	  --sourceNode;--sinkNode;

	  if(nodePtrList[sourceNode] == NULL) nodePtrList[sourceNode] = new Node(sourceNode);
	  if(nodePtrList[sinkNode] == NULL) nodePtrList[sinkNode] = new Node(sinkNode);
	  addEdge(branchValue,CurrentSource,nodePtrList[sourceNode],nodePtrList[sinkNode],i);
	  scalecapacity += branchValue; 
          if(MAXcapacity < branchValue) MAXcapacity = branchValue; 
          flowCost+=branchValue*double(cost);
	  break;	
        case 'V' :
	  sscanf(tempStr,"V %d %d %*d %lf",&sourceNode,&sinkNode,&branchValue);
	  sourceNode = assignNodeNumber(sourceNode);
          sinkNode = assignNodeNumber(sinkNode); 
	  --sourceNode;--sinkNode;
	  if(nodePtrList[sourceNode] == NULL) nodePtrList[sourceNode] = new Node(sourceNode);
	  if(nodePtrList[sinkNode] == NULL) nodePtrList[sinkNode] = new Node(sinkNode);
	  addEdge(branchValue,VoltageSource,nodePtrList[sourceNode],nodePtrList[sinkNode],i);
	  branchValue*=10000;
          scalecost += branchValue; 
          if(MAXcost < branchValue ) MAXcost = branchValue ; 
          ++_VoltageSource;
 	  break;	
	case 'c' : break; // comment 
	default : cout <<"File doesn't looks to be in DIMACS format " << endl;exit(0);  
      }
  }
  fclose(from);
   
  cout<<"FlowGraph : Nodes are " << _Nodes << " and Edges are " << _Edges  << endl ; 
  _Nodes += (_Edges+_Edges-2*_SimplifiedEdges); 
  _VoltageSource +=(_Edges-_SimplifiedEdges); 
  _Diode = (_Edges+_Edges-2*_SimplifiedEdges);
  _Edges = 6*_Edges + _ExcessNodes-5*_SimplifiedEdges;
  edge e;
 
  scalecost/= _Edges;         //why averaging technique is used? & why averaging is done using circuit edges?   
  scalecapacity /= _Edges;
  cout<<"Max capacity: "<<MAXcapacity<<" Max Cost: "<<MAXcost<<endl;
  if(scaleParameter == 0) {scalecapacity = 1 ; scalecost = 1; }
  else  
  {
	scalecapacity /=scaleParameter; 
	scalecost /=scaleParameter;
/*  	if(MAXcapacity<1000 || scalecapacity<1)
		scalecapacity=1;
	if(MAXcost<1000 || scalecost<1)
		scalecost=1; */
        if(scalecost<1)
		scalecost=1;
	if(scalecapacity<1)
		scalecapacity=1;
        MAXcapacity/=scalecapacity;
        MAXcost/=scalecost;
        while(MAXcost>3000){
		scalecost*=2;
		MAXcost/=2;
	} 
// Maximum cost Scaling
/*        if(MAXcapacity < MAXcost)
		scalecapacity*=MAXcapacity/MAXcost;
        if(MAXcapacity > MAXcost)
		scalecost*=MAXcost/MAXcapacity;*/

// Maximum capacity Scaling
/*        if(MAXcapacity < MAXcost)
		scalecost*=MAXcost/MAXcapacity;
        if(MAXcapacity > MAXcost)
		scalecapacity*=MAXcapacity/MAXcost;*/

// Geometical mean(of Max Cap and Max Cost) Scaling	
//	scalecost*=sqrt(MAXcost*MAXcapacity)/(MAXcapacity);
//	scalecapacity*=sqrt(MAXcapacity*MAXcost)/(MAXcost);

// Fixed value Scaling
/*        scalecost*=MAXcost/500;
	scalecapacity*=MAXcapacity/500;*/
	cout<< "modified scale cost: "<<scalecost<<" scale capacity: "<< scalecapacity<<endl; 
	double max_capacity=0.0,max_cost=0.0,min_capacity=1.0;
        for(int i=0;i<_Edges;++i)
	{
	  e = edgePtrList[i];
	  if(e->isEdgeType(VoltageSource))
	    	e->Voltage /= scalecost ; 
	  if(e->isEdgeType(Diode)) ++i; 
	  if(e->isEdgeType(CurrentSource)){ 
		e->EdgeValue /= scalecapacity;
          if(max_capacity<e->EdgeValue)
		max_capacity=e->EdgeValue;
          if(min_capacity>e->EdgeValue && e->EdgeValue)
		min_capacity=e->EdgeValue;
          }
	  if(max_cost<e->Voltage)
		max_cost=e->Voltage; 
	}
	cout<<"Max capacity: "<<max_capacity<<" Max Cost: "<<max_cost<<" Min Capacity: "<<min_capacity<<endl;
  }
  firstNode = nodePtrList[0] ; 
  cout<<"Equivalent Circuit : Nodes are " << _Nodes << " and Edges are " << _Edges <<"Excess "<<_ExcessNodes<< endl ; 
}
#endif

void GraphOfNetwork::addEdge(double Value,char Type,node Source,node Sink,int& i)
{
  edgePtrList[i] = new Edge(Value,Type,Source,Sink);
  Source->addEdgeList(edgePtrList[i]);
  Sink->addEdgeList(edgePtrList[i]);
  ++i;
}

void GraphOfNetwork::addDiodeEdge(node Source,node Sink,int& i)
{
  // a diode is a Resistance Diode and current source CurrentSource in parallel 
  edgePtrList[i] = new Edge(Gval,Diode,Source,Sink);
  Source->addEdgeList(edgePtrList[i]);
  Sink->addEdgeList(edgePtrList[i]);
  ++i; 
  edgePtrList[i] = new Edge(0,CurrentSource,Source,Sink);
  Source->addEdgeList(edgePtrList[i]);
  Sink->addEdgeList(edgePtrList[i]);
  ++i;
}

#ifdef DCANA 

void GraphOfNetwork::convertCircuitIntoGraph(char* circuitName)
{
  char edgeType,tempStr[80];
  int sourceNode=0,sinkNode=0;
  double branchValue=0;

  FILE* from;
  from=fopen(circuitName,"r+");
  if(from == NULL) 
  {
	cout<<" *********Error*********" <<endl;
	cout<<" Circuit File Not Found " <<endl;
	exit(0);
  }

  while (fgets(tempStr, 80, from) != NULL)
  {
	if(tempStr[0]=='.')
	  break;
	if(tempStr[0]==Diode)
	  ++_Diode;
	++_Edges;
	sscanf(tempStr, "%*s %d %d %*s", &sourceNode, &sinkNode);
	if(sourceNode> _Nodes) _Nodes=sourceNode;
	if(sinkNode >  _Nodes) _Nodes=sinkNode;
  }
  ++_Nodes;
  _Edges +=_Diode;
  nodePtrList = (node*) calloc(_Nodes,sizeof(node)); 
  edgePtrList = (edge*) calloc (_Edges,sizeof(edge));
  fclose(from);
  from=fopen(circuitName,"r+");
  int i=0;
  do
  {
	fscanf(from,"%c%*d %d %d",&edgeType,&sourceNode,&sinkNode);
	if(nodePtrList[sourceNode]==NULL) nodePtrList[sourceNode]=new Node(sourceNode);
	if(nodePtrList[sinkNode]==NULL)  nodePtrList[sinkNode]=new Node(sinkNode);
	switch(edgeType)
	{
	  case VoltageSource:
		++_VoltageSource;
	  case CurrentSource:
	  case Resistance:
		fscanf(from,"%lf\n",&branchValue);
		if(edgeType==Resistance)
		{
		  if(branchValue < 1e-6) 
		  {
			++_VoltageSource;
			edgeType=VoltageSource;
		  }
		  else
			branchValue=1.0/branchValue;
		}
		addEdge(branchValue,edgeType,nodePtrList[sourceNode],nodePtrList[sinkNode],i);
		break;
	  case Diode:
		fscanf(from,"%s\n",tempStr);
		if(strcmp(tempStr,"MOD1"))
		  addDiodeEdge(nodePtrList[sourceNode],nodePtrList[sinkNode],i);
		break;
	  case '.':
		fscanf(from,"%s",tempStr);
		if(strcmp(tempStr,"end")==0)
		  break;
	  default : 
		cout << "Error : Check the circuit : Only use RVID circuits" << endl;
		exit(1);
	}
  }
  while(edgeType!='.');
  fclose(from);
  cout <<" Total Nodes : " << _Nodes << " Total Edges : " << _Edges << endl;
  cout <<" Total Voltage Sources : " << _VoltageSource;
   _Diode==0?:cout<<" Diodes : "<< _Diode;
  firstNode = nodePtrList[0] ; 
  cout<<endl;
}
#endif 

double GraphOfNetwork::printSolution(char* cktfile)
{
  char solution[80];
  edge e; 
  double totalPower=0,Gval; 
  int count=0;
/*  strcpy(solution,cktfile);
  strcat(solution,".volts");
  FILE *to = fopen (solution, "w+");
  fprintf(to,"      N         Voltage            Current             \n");
  fprintf(to,"      -------------------------------------------------\n");
  for(int i=0;i<_Edges;++i)
  {
	e=edgePtrList[i];
	if(e->isEdgeType(Diode)) 
	{
	  Gval = e->EdgeValue / e->Voltage ; 
	  fprintf (to, "%7d %c %15lf V %15lf A %15lf \n",++count,e->EdgeType,e->Voltage,e->EdgeValue,Gval);
	} else 
	  fprintf (to, "%7d %c %15lf V %15lf A \n",++count,e->EdgeType,e->Voltage,e->EdgeValue);
	totalPower+= e->Voltage*e->EdgeValue;
#ifdef MCF 
	if(!(count%6)) 
	{ 
	  fprintf(to,"\n");
	}
#endif 
  }
  fclose (to);
  printf("Solution written to file %s\n",solution);*/
  
  strcpy(solution,cktfile);
  strcat(solution,".sol");
  FILE *mcf_sol= fopen (solution, "w+");
  fprintf(mcf_sol,"      N         Voltage            Current             \n");
  fprintf(mcf_sol,"      -------------------------------------------------\n");
  count=0;
  double diodeI;  
  for(int i=0;i<_Edges;++i)
  {
	e=edgePtrList[i];
	if(e->isEdgeType(Diode)) 
	{
	  Gval = e->EdgeValue / e->Voltage ; 
	  diodeI=e->EdgeValue+edgePtrList[++i]->EdgeValue;
          if(scalecapacity-scalecost>0)
             if((diodeI<sqrt(scalecapacity-scalecost)||(diodeI<scalecapacity/10)) && diodeI>0.8 && i%6==2) // flowedge is declared as failed if very small current flowing through it.
                e->devCharNotSatisfied=true;
          if(diodeI/e->Voltage < 0)
                e->devCharNotSatisfied=true;
	  fprintf (mcf_sol, "%7d %15lf V %15lf A %15lf %d\n",++count,e->Voltage,diodeI,Gval,e->devCharNotSatisfied);
	} else 
	  fprintf (mcf_sol, "%7d %15lf V %15lf A \n",++count,e->Voltage,e->EdgeValue);
  }
  printf("Solution written to file %s\n",solution);
  fclose (mcf_sol);
  return totalPower; 
}

#ifdef MCF
void GraphOfNetwork::scaling()
{
  edge e;	
  for(int i=0;i<_Edges;++i)
  {
	e=edgePtrList[i];
	e->Voltage *= scalecost;
        e->EdgeValue *= scalecapacity;
  }
}
/*
void GraphOfNetwork::printFlowInfo(char* cktfile)
{
  char file[80];
  strcpy(file,cktfile);
  FILE *problem;
  char tempStr[80];
  problem=fopen(file,"r");
  if(!_SimplifiedEdges)
	while(fgets(tempStr,80,problem)!=NULL)
		if(tempStr[0]=='a')
			break;
  		
  strcat(file,".flow");
  FILE *flow;
  flow=fopen(file,"w+");
  if(_SimplifiedEdges)	
  	fprintf(flow,"      N         Voltage            Current             \n");
  else	
  	fprintf(flow,"    N   Source   Sink   Cost    Capacity   Flow          \n");
  fprintf(flow,"      -------------------------------------------------\n");

  edge e;
  fgedge e1;
  double power=0;
  int* Node_current = (int*) calloc(_Nodes,sizeof(int));
  if(_SimplifiedEdges){
     for(int i=0;i<_Edges;++i)
     {
        e=edgePtrList[i];
        if(e->isEdgeType(VoltageSource)&& e->EdgeValue>0){
       // if(e->isEdgeType(VoltageSource)){
            power=e->Voltage*e->EdgeValue;
            flowCost+=power;
         }
     }
     printf("Min Flow Cost without rounding %lf\n",flowCost);
     
     flowCorrection(cktfile,Node_current);
     flowCost=0;
     strcpy(file,cktfile);
     strcat(file,".lfg");
     FILE *RFG=fopen(file,"w+");
     fprintf(RFG,"c Reduced MinCostFlow problem\n");
     fprintf(RFG,"p min %d %d\n",_Nodes,_Edges);
     forall_fgedges(e1){
         fprintf(RFG,"a %d %d 0 %d %d 0\n",e1->Source->nodeNumber+1,e1->Sink->nodeNumber+1,e1->Capacity-(int)e1->EdgeValue,(int)e1->Voltage);
 	 flowCost+=e1->Voltage*e1->EdgeValue;
//	 cout<<e1->EdgeValue<<endl;
     }
     printf("FlowCost: %lf\n",flowCost);	
     for(int i=0;i<_Nodes;++i)
       if(Node_current[i]!=0)
             fprintf(RFG,"n %d %d\n",i+1,(Node_current[i]*-1));
     fclose(RFG);
     free(Node_current);
  }
  fclose(flow);
}*/
#endif

int GraphOfNetwork::assignNodeNumber(int NodeNumber)
{
	static int dummyNode=1;
	if(nodeTable[NodeNumber]==0){
                nodeTable[NodeNumber]=dummyNode;
                reverseNodeTable[dummyNode]=NodeNumber;  
                ++dummyNode;
	}
	return nodeTable[NodeNumber];
}
