#include "global.h"
bool FlowGraph::classifyFlowEdges(char* flowGraphName)
{
  char tempStr[80];
  char rsltv[80],rsltdp[80],rsltds[80],rslti[80];
  char junk[80]; 
  int sourceNode=0,sinkNode=0,capacity=0,cost=0;
  int _Unsaturated=0,_Saturated=0,_Off=0;
  int nodeNumber=0,tempflow=0;
  double diodeI,dsV,dpV;
  int failed=1,failed_dp=1;
  const float excessIsat = -0.1;
  double offcurrent=0.1;
  int satCost;
  FILE *fg; 
  fg=fopen(flowGraphName,"r+");
  if(fg == NULL)
  {
	cout<<" *********Error*********" <<endl;
	cout<<" Flow Circuit File Not Found " <<endl;
	exit(0);
  }
  
  FILE *fgSol;
  char flowGraphSol[80];
  strcpy(flowGraphSol,flowGraphName);
  strcat(flowGraphSol,".sol");
  fgSol=fopen(flowGraphSol,"r+");
  if(fgSol == NULL)
  {
	cout<<" *********Error*********" <<endl;
	cout<<" Flow Circuit Solution File Not Found " <<endl;
	exit(0);
  }
  
  fgets(junk,80,fgSol);
  fgets(junk,80,fgSol);
  int i=0;
  while (fgets(tempStr,80,fg)!=0)
  {
    switch(tempStr[0])
    {
	case 'p':
	  sscanf(tempStr,"p min %d %d %d",&_Nodes,&_Edges,&_SimplifiedEdges);
	  nodePtrList = (node*) calloc(_Nodes,sizeof(node));
	  edgePtrList = (edge*) calloc(_Edges,sizeof(edge));
          break;
 	case 'n':
	  sscanf(tempStr,"n %d %d",&nodeNumber,&tempflow);
          if(tempflow > 0){	
		flowSource = nodeNumber;
 	  	nodeCurrent= tempflow;
	  }	
	  else 
		flowSink = nodeNumber; 
	  break;
        case 'I':
	{
	  fgets(rslti,80,fgSol);
	  sscanf(tempStr,"I %d %d %lf %d %d",&sourceNode,&sinkNode,&diodeI,&capacity,&cost);
          --sourceNode;--sinkNode;
	  if(nodePtrList[sourceNode] == NULL) nodePtrList[sourceNode] = new Node(sourceNode);
          if(nodePtrList[sinkNode] == NULL) nodePtrList[sinkNode] = new Node(sinkNode);
	  addFlowEdge(nodePtrList[sourceNode],nodePtrList[sinkNode],capacity,cost,diodeI,CurrentSource,i);	
	  break;
        }
        case 'a':
	{
	  fgets(rsltv,80,fgSol);
	  fgets(rsltds,80,fgSol);
	  fgets(rsltdp,80,fgSol);
	  fgets(rslti,80,fgSol);
	  sscanf(tempStr,"a %d %d %*d %d %d",&sourceNode,&sinkNode,&capacity,&cost);
	  sscanf(rsltds,"%*d %lf V %lf A %*f %d",&dsV,&diodeI,&failed);
	  sscanf(rsltdp,"%*d %lf V %*f A %*f %d",&dpV,&failed_dp);
           --sourceNode;--sinkNode;
	  if(nodePtrList[sourceNode] == NULL) nodePtrList[sourceNode] = new Node(sourceNode);
	  if(nodePtrList[sinkNode] == NULL) nodePtrList[sinkNode] = new Node(sinkNode);
          if(capacity>nodeCurrent)
		capacity=nodeCurrent;
	  if(failed_dp || failed){
		addFlowEdge(nodePtrList[sourceNode],nodePtrList[sinkNode],capacity,cost,diodeI,ERR,i);
	 }
	  else if(diodeI-capacity >= excessIsat  && capacity!=0)  //Saturated
	  {
		addFlowEdge(nodePtrList[sourceNode],nodePtrList[sinkNode],capacity,cost,diodeI,SAT,i);
		satCost+= cost*capacity;
		++_Saturated;
	  }
	  else if(diodeI <= offcurrent || capacity==0){  //Off Branches
		addFlowEdge(nodePtrList[sourceNode],nodePtrList[sinkNode],capacity,cost,diodeI,OFF,i);
		++_Off;
	  }
	  else if(fabs(dsV-dpV)<0.1){
		addFlowEdge(nodePtrList[sourceNode],nodePtrList[sinkNode],capacity,cost,diodeI,UNSAT,i);
		++_Unsaturated;
	  }
	  else
		addFlowEdge(nodePtrList[sourceNode],nodePtrList[sinkNode],capacity,cost,diodeI,ERR,i);
	  break;
        }
        case 'c':
	  break;
        default : cout <<"File doesn't looks to be in DIMACS format " << endl;exit(0);  
    }
  }
  cout<<"Saturated:"<<_Saturated<<endl;
  cout<<"_Unsaturated:"<<_Unsaturated<<endl;
  cout<<"_Off:"<<_Off<<endl; 
/* edge e;
 for(int i=0; i<_Edges;++i)
 {
	e=edgePtrList[i];
	cout<<e->Source->nodeNumber+1<<" "<<e->Sink->nodeNumber+1<<" "<<e->EdgeCost<<"  "<<e->EdgeClass<<endl;
 }*/ 
 if(_SimplifiedEdges)
	return true;
 else
	return false; 
}

void FlowGraph::addFlowEdge(node Source,node Sink,int Capacity,int Cost,double DiodeI,char Type,int& i)
{
  edgePtrList[i] = new Edge(Source,Sink,Capacity,Cost,DiodeI,Type);
  Source->addEdgeList(edgePtrList[i]);
  Sink->addEdgeList(edgePtrList[i]);
  ++i;
}


