#include "costCorr.h"

void Graph::checkBranchOnOff(char* cktFile,char* solFile, int& shNodes, int& shEdges, 
                             int& ssNode, double* costCalculated, double* calcBranchVoltage,
							 bool* edgeInfo)
{
  cout << "nodes " << shNodes << " edges " << shEdges << endl;

  int index=0;
  double bVolVal=0,bCurVal=0;

  FILE* from=NULL;
  from = fopen(solFile,"r+");
  int k=0;

  //double* tempCostCalculated = (double*) calloc(shNodes,sizeof(double));
  int howManyPositive=0;
  for(int i=1;i<=shEdges+shNodes-1;i++)
  {
	//cout << "i is " << i << endl;

	if(i<=shEdges)
	{
	  fscanf(from,"%d%lf%lf\n",&index,&bVolVal,&bCurVal);
	  if(bVolVal>= 0)
	  {
		edgeInfo[i]=1;
		howManyPositive++;
	  }
	  //cout << i << " " << bVolVal << " " << bCurVal << endl;
	  calcBranchVoltage[i] = bVolVal;
	  fscanf(from,"%d%lf%lf\n",&index,&bVolVal,&bCurVal);
	  //cout << shEdges+i << " " << bVolVal << " " << bCurVal << endl;
	  calcBranchVoltage[shEdges+i] = bVolVal;
	}
	else if(i>shEdges)
	{
	  fscanf(from,"%d%lf%lf\n",&index,&bVolVal,&bCurVal);
	  //cout << i << " " << bVolVal << " " << bCurVal << endl;
	  if(k<ssNode)
		costCalculated[k]=bVolVal;
	  else
		costCalculated[k+1]=bVolVal;
	  //tempCostCalculated[k]=bVolVal;
	  //cout << k << endl;
	  k++;
	}
	//cout << "i is " << i << endl;
  }
  cout << "howManyPositive " << howManyPositive << endl;
  //getchar();
/*  int countTree=0;
  //FILE* tfp = fopen("aisehi","w+"); 
  for(int i=1;i<=2*shEdges;i=i+2)
  {
	//fprintf(tfp,"%d %lf\n",i,calcBranchVoltage[i]);
	if(i<=2*(shNodes-1) && calcBranchVoltage[i]>0) 
	  countTree++;
	
	//if(i<=2*(shNodes-1) && calcBranchVoltage[i]<0 )
	//  cout << i << " " << calcBranchVoltage[i] << endl;
  }
  //fclose(tfp);
  cout << "countTree " << countTree << endl;*/
  //cout << "here" << endl;
  fclose(from);

  return;
}

void Graph::readGraphForShortestPath(char* shGph, int& shNodes, int& shEdges)
{
  clock_t time1=clock();

  FILE* from = fopen(shGph,"r");
  if(from == NULL)
  {
	cout<<" *********Error*********" <<endl;
	cout<<"Graph Information for Shortest Path calcution Not Found!" <<endl;
	exit(1);
  }

  fscanf(from,"%d %d\n",&shNodes,&shEdges);
  cout << "Graph : nodes " << shNodes << " edges " << shEdges << endl;

  nodePtrList = (node*) calloc(shNodes,sizeof(node));
  edgePtrList = (edge*) calloc (shEdges,sizeof(edge));

  int branchNum=0,sourceNode=0,sinkNode=0;
  double cost=0;

  for(int i=1;i<=shEdges;i++)
  {
	//fscanf(from,"%d %d %d %d\n",&branchNum,&sourceNode,&sinkNode,&cost);
	fscanf(from,"%d %d %d %lf\n",&branchNum,&sourceNode,&sinkNode,&cost);

	if(nodePtrList[sourceNode] == NULL) nodePtrList[sourceNode] = new Node(sourceNode);
	if(nodePtrList[sinkNode] == NULL) nodePtrList[sinkNode] = new Node(sinkNode);

	addEdge(cost,'R',nodePtrList[sourceNode],nodePtrList[sinkNode],i-1,branchNum);
  }

  fclose(from);

  _Nodes = shNodes; 
  _Edges = shEdges; 
  cout<<"Equivalent Circuit : Nodes are " << _Nodes << " and Edges are " << _Edges << endl ; 
  cout<<"Circuit made from Graph time = "<<double(clock()-time1)/CLOCKS_PER_SEC<<endl; 

  return;
}

void Graph::addEdge(double Value,char Type,node Source,node Sink,int index,int branchNum)
{
  edgePtrList[index] = new Edge(Value,Type,Source,Sink,branchNum);
  Source->addEdgeList(edgePtrList[index]);
  Sink->addEdgeList(edgePtrList[index]);
}


bool Graph::adjustDiodeVoltages(int& shNodes, int& shEdges, int& ssNode, 
	double* costCalculated, double* calcBranchVoltage, bool* edgeInfo)
{
  bool status=false;

  queue <node> queueOfNodes; 
  queueOfNodes.push(nodePtrList[ssNode]);

  bool* nodeCovered = (bool*) calloc(_Nodes,sizeof(bool));
  double* volSourceDropTillNode = (double*) calloc(_Nodes,sizeof(double));

  volSourceDropTillNode[ssNode]=0;

  nodeCovered[ssNode] = true; 

  int* predecessor = new int[_Nodes];
  for(int i=0;i<_Nodes;i++)
  	predecessor[i] = 0;
 
  predecessor[ssNode] = -1;

  edge e;
  node n1,n2;
  int counter=0;
  double tempCost=0;

  //cout << "Reached here" << endl;
  while(!queueOfNodes.empty())
  {
	n1=queueOfNodes.front();
	//if(counter==shNodes-1) break;
	for(list<edge>::iterator itr = (n1->edgeList).begin();itr!=(n1->edgeList).end();++itr)
	{
	  e=(*itr);
	  
	  if(n1!=e->Source)continue;
	  else n2= e->Sink;

	  if(n1==n2) continue;

	  //if(!e->edgeCovered && calcBranchVoltage[e->edgeNumber]>0)
	  if(!e->edgeCovered && edgeInfo[e->edgeNumber]== 1)
	  {
		//cout << e->edgeNumber << " " << e->Source->nodeNumber << " " << e->Sink->nodeNumber << " " << edgeInfo[e->edgeNumber] << endl;
		if(!nodeCovered[n2->nodeNumber])
		{
		  counter++;
		  nodeCovered[n2->nodeNumber]=true;

		  volSourceDropTillNode[n2->nodeNumber] = calcBranchVoltage[e->edgeNumber+shEdges] +
			costCalculated[n1->nodeNumber];

			  costCalculated[n2->nodeNumber] = volSourceDropTillNode[n2->nodeNumber];
		  predecessor[n2->nodeNumber] = n1->nodeNumber;
		  queueOfNodes.push(n2);
		}
		else
		{
		  //cout << "here" << endl;
		  tempCost = calcBranchVoltage[e->edgeNumber+shEdges] + costCalculated[n1->nodeNumber];
			  
		  if(tempCost < costCalculated[n2->nodeNumber])
		  {
			costCalculated[n2->nodeNumber] = tempCost;
			predecessor[n2->nodeNumber] = n1->nodeNumber;
		  }
		}
		e->edgeCovered=true;
	  }
	}
	queueOfNodes.pop();
  }

  //cout << "GT " << costCalculated[1401] << endl;
  cout << "GT counter " << counter << endl;

  delete [] nodeCovered;
  delete [] volSourceDropTillNode;
  delete [] predecessor;

  return status=true;
}

void correctCost(char* cktFile,char* solFile, char* shGphFile, int ssNode, double scaler, char upDown)
{
  bool status=false;
  Graph G;
  int shNodes=0, shEdges=0;
  cout << "shGphFile " << shGphFile << endl;
  G.readGraphForShortestPath(shGphFile,shNodes,shEdges);

  double* costCalculated = (double*) calloc(shNodes,sizeof(double));
  costCalculated[ssNode]= 0;
  double* calcBranchVoltage = (double*) calloc((2*shEdges)+1,sizeof(double));
  bool* edgeInfo = (bool*) calloc((shEdges+1),sizeof(bool));

  G.checkBranchOnOff(cktFile,solFile,shNodes,shEdges,
	  ssNode,costCalculated,calcBranchVoltage,edgeInfo);
  
  double* actualCostCalculated = (double*) calloc(shNodes,sizeof(double));
  actualCostCalculated[ssNode]= 0;
  
  FILE *from = fopen(shGphFile,"r");
  int tmp1=0,tmp2=0,bNum=0,soindex=0,sindex=0;
  double value=0;
  fscanf(from,"%d%d\n",&tmp1,&tmp2);
  for(int i=1;i<=shEdges;i++)
  {
	fscanf(from,"%d%d%d%lf\n",&bNum,&soindex,&sindex,&value);
	//cout << bNum << " " << soindex << " " << sindex << " " << value << endl;
	//getchar();
	calcBranchVoltage[shEdges+i]=value;
  }
  fclose(from);

  //for(int i=0;i<shEdges;i++)
  //	cout << calcBranchVoltage[shEdges+i] << endl;

  status=G.adjustDiodeVoltages(shNodes,shEdges,ssNode,
	  actualCostCalculated,calcBranchVoltage,edgeInfo);
  //  cout << "here 1" << endl;

  FILE* fpSol=fopen("correctShPathDCana","w+");

  if(status)
  {
	//cout << "Corrected Shortest Path is : " << endl;
	  for(int i=0;i<shNodes;++i)
	  {
		  //cout << i << " " << costCalculated[i] << endl;
		  if(upDown=='u')
			  fprintf(fpSol,"%d %lf\n",i,actualCostCalculated[i]/scaler);
		  else
			  fprintf(fpSol,"%d %lf\n",i,actualCostCalculated[i]*scaler);
		  //fprintf(fpSol,"%d %lf\n",i,costCalculated[i]);
	  }
  }
  fclose(fpSol);

  // Here it does an extra job making all -ve costs positive

  makeNegativePositive(shGphFile,actualCostCalculated,ssNode);

  // Extra work completes

  delete [] costCalculated;
  delete [] actualCostCalculated;
  //  cout << "here" << endl;
  delete [] calcBranchVoltage;
  delete [] edgeInfo;
  //  cout << "here" << endl;
  G.deleteGraph();
}

void makeNegativePositive(char* shGph, double* nodePoential, int ssNode)
{

	int nodes=0,edges=0;
	int index=0,source=0,sink=0,value=0;

	FILE* from = fopen(shGph,"r+");
	FILE* to = fopen("newShPathGph","w+");
	FILE* toCkt = fopen("newEqCircuit","w+");

	fscanf(from,"%d%d\n",&nodes,&edges);
	cout << nodes << " " << edges << endl;
	fprintf(to,"%d %d\n",nodes,edges);

	//int counter=0;
	for(int i=0;i<edges;i++)
	{
		fscanf(from,"%d%d%d%d\n",&index,&source,&sink,&value);
		//cout << index << " " << source << " " << sink << " " << value << endl;
		fprintf(to,"%d %d %d %d\n",index,source,sink,-1*int(nodePoential[sink]-nodePoential[source])+ value);
		fprintf(toCkt,"D%d %d %d %s\n",index,source,nodes+i,"DMOD1");
		fprintf(toCkt,"V%d %d %d %d\n",edges+index,nodes+i,sink,-1*int(nodePoential[sink]-nodePoential[source])+ value);
		//printf("%d %d %d %d\n",index,source,sink,int(nodePoential[sink]-nodePoential[source])+value);
		//getchar();	
		//fscanf(from,"%d%d%d%d\n",&index,&source,&sink,&value);
		//fprintf(to,"%d %d %d %d\n",index,source,sink,int(nodePoential[sink]-nodePoential[source])+value);
	}

	for(int i=0;i<nodes;i++)
	{
		if (i==ssNode) continue;
		fprintf(toCkt,"I%d %d %d %lf\n",2*edges+i,i,ssNode,0.1);
	}

	fprintf(toCkt,"%s\n",".end");

	fclose(toCkt);
	fclose(to);
	fclose(from);

}
