bool Graph::adjustDiodeVoltages(int& shNodes, int& shEdges, int& ssNode, 
	double* costCalculated, double* calcBranchVoltage, bool* edgeInfo)
{
  bool status=false;

  queue <node> queueOfNodes; 
  queueOfNodes.push(nodePtrList[ssNode]);

  bool* nodeCovered = (bool*) calloc(_Nodes,sizeof(bool));
  double* volSourceDropTillNode = (double*) calloc(_Nodes,sizeof(double));

  volSourceDropTillNode[ssNode]=0;

  nodeCovered[ssNode] = true; 

  int* predecessor = new int[_Nodes];
  for(int i=0;i<_Nodes;i++)
  	predecessor[i] = 0;
 
  predecessor[ssNode] = -1;

  edge e;
  node n1,n2;
  int counter=0;
  double tempCost=0;

  //cout << "Reached here" << endl;
  while(!queueOfNodes.empty())
  {
	n1=queueOfNodes.front();
	//if(counter==shNodes-1) break;
	for(list<edge>::iterator itr = (n1->edgeList).begin();itr!=(n1->edgeList).end();++itr)
	{
	  e=(*itr);
	  
	  if(n1!=e->Source)continue;
	  else n2= e->Sink;

	  if(n1==n2) continue;

	  //if(!e->edgeCovered && calcBranchVoltage[e->edgeNumber]>0)
	  if(!e->edgeCovered && edgeInfo[e->edgeNumber]== 1)
	  {
		//cout << e->edgeNumber << " " << e->Source->nodeNumber << " " << e->Sink->nodeNumber << " " << edgeInfo[e->edgeNumber] << endl;
		if(!nodeCovered[n2->nodeNumber])
		{
		  counter++;
		  nodeCovered[n2->nodeNumber]=true;

		  volSourceDropTillNode[n2->nodeNumber] = calcBranchVoltage[e->edgeNumber+shEdges] +
			costCalculated[n1->nodeNumber];

			  costCalculated[n2->nodeNumber] = volSourceDropTillNode[n2->nodeNumber];
		  predecessor[n2->nodeNumber] = n1->nodeNumber;
		  queueOfNodes.push(n2);
		}
		else
		{
		  //cout << "here" << endl;
		  tempCost = calcBranchVoltage[e->edgeNumber+shEdges] + costCalculated[n1->nodeNumber];
			  
		  if(tempCost < costCalculated[n2->nodeNumber])
		  {
			costCalculated[n2->nodeNumber] = tempCost;
			predecessor[n2->nodeNumber] = n1->nodeNumber;
		  }
		}
		e->edgeCovered=true;
	  }
	}
	queueOfNodes.pop();
  }

  //cout << "GT " << costCalculated[1401] << endl;
  cout << "GT counter " << counter << endl;

  delete [] nodeCovered;
  delete [] volSourceDropTillNode;
  delete [] predecessor;

  return status=true;
}


