#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<math.h>
#include<cstdlib>
#include<vector>
#include<string>
#include<list>
#include<map>
#include<algorithm>
#include<iostream>
#include<fstream>

#ifndef _SPGGEN_H 
#define _SPGGEN_H

#ifndef _GLOBAL_H
#include "global.h"
#endif

#ifndef _CONVERTER_H
#include "converter.h"
#endif

enum {FALSE,TRUE};

class Circuit 
{
  private:
	
	Int numberOfNodes;
	Int numberOfBranches;
	Int numberOfResistances;
	Int numberOfVoltageSources;
	Int numberOfCurrentSources;
	Int numberOfDiodes;
//	int numberOfCapacitances;
//	int numberOfInductances;
//	int numberOfCCVS;
//	int numberOfVCCS;
//	int numberofCCCS;
//	int numberofVCVS;

	list<Int> nodeInWindow; // Holds the information abt
							// nodes in which windows 
							// and having how many edges
							// connected (minimum is 2)
	Int nodesInArowOfInnerGrid; // For the planar circuit only 
	Int nodesInArowOfOuterGrid; // For the planar circuit only
	Char typeOfBranch;	// It tells wheather it is 
						// resistance, capacitance 
						// or some other type of branch.
	
  public:
	Circuit()				// Constructor
	{
	  numberOfNodes=0;
	  numberOfBranches=0;
	  numberOfResistances=0;
	  numberOfVoltageSources=0;
	  numberOfCurrentSources=0;
	  numberOfDiodes=0;
	  nodesInArowOfOuterGrid=0;
	  nodesInArowOfInnerGrid=0;
	}
		
	Int totalNumberOfNodes(){return numberOfNodes;}
	Int totalNumberOfBranches(){return numberOfBranches;}
	void setCircuitNodeCount(Int nodes){numberOfNodes = nodes;}
	void setCircuitBranchCount(Int branches){numberOfBranches= branches;}
	Int showCircuitNodeCount(){return numberOfNodes;}
	Int showCircuitBranchCount(){return numberOfBranches;}

	void setParametersOfNonPlanarCircuit(Double,Double,Double,Double);
	void setParametersOfDenseNonPlanarCircuit(Double,Double,Double,Double);
	void setParametersOfNonPlanarCircuitWithDiode(Double,Double,Double,Double,Double);
	void setParametersOfNonPlanarCircuitWithDiodeButNoResistance(Double,Double,Double,Double,Double);
	void setParametersOfUnEvenWinPlanarCircuit(Double,Double,Double);
	void setParametersOfPlanarCircuit(Double,Double,Double);
	void setParametersOfPlanarCircuitWithDiode(Double,Double,Double,Double);
	void setParametersOfPlanarCircuitWithDiodeButNoResistance(Double,Double,Double,Double);
	void showNonPlanarCircuitParameters();
	void showDenseNonPlanarCircuitParameters();
	void showNonPlanarCircuitParametersWithDiode();
	void showNonPlanarCircuitParametersWithDiodeButNoResistance();
	void showUnEvenWinPlanarCircuitParameters();
	void showPlanarCircuitParameters();
	void showPlanarCircuitParametersWithDiode();
	void showPlanarCircuitParametersWithDiodeButNoResistance();
	void generateNonPlanarCircuit(char*);	// Generates a nonplanar circuit
	void generateDenseNonPlanarCircuit(char*);	// Generates a nonplanar circuit
	void generateNonPlanarCircuitWithDiodes(char*);	// Generates a nonplanar circuit
	void generateNonPlanarCircuitWithDiodesButNoResistance(char*);
	void generateUnEvenWinPlanarCircuit();	// Generates a planar circuit
	void generatePlanarCircuit();	// Generates a planar circuit
	void generatePlanarCircuitWithDiodes();	// Generates a planar circuit
	void generatePlanarCircuitWithDiodesButNoResistance();
};
#endif
