#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<iostream>
#include<fstream>

using namespace std;

int main(int argc,char** argv)
{	
  if(argc<4)
  {
	cout << "matchResultsGTLdcAna gtlSol.file dcAnaSolAfterCorrection.file vScaleFactor up/down(u/d)" << endl;
	exit(1);
  }

  int nodes=0,edges=0,source=0;
  
  FILE *from = fopen(argv[1],"r+");
  
  if(from == NULL)
  {
	cout<<" *********Error*********" <<endl;
	cout<<" GTL calculated cost dataFile Not Found! Terminating!" <<endl;
	exit(2);
  }

  fscanf(from,"%d%d%d\n",&nodes,&edges,&source);
  cout << nodes << " " << edges << " " << source << endl;
  
  int* gtlCost = (int*) calloc(nodes,sizeof(int));
  gtlCost[source] = -1;
 
  int index=0, value=0;
  
  for(int i=1;i<nodes;i++)
  {
	fscanf(from,"%d%d\n",&index,&value);
	gtlCost[index] = value;
	//cout << index << " " << value << endl;
  }

  fclose(from);

  from = fopen(argv[2],"r+");
  
  if(from == NULL)
  {
	cout<<" *********Error*********" <<endl;
	cout<<" DC analyzer calculated cost dataFile Not Found! Terminating!" <<endl;
	exit(3);
  }

  double* dcCost = (double*) calloc(nodes,sizeof(double));
  dcCost[source] = -1;
 
  double value1=0;
  index=0; 
  //FILE *to=fopen("t123","w+");
  for(int i=0;i<nodes;i++)
  {
	fscanf(from,"%d %lf\n",&index,&value1);
	dcCost[index] = fabs(value1);
	//if(atoi(argv[4])=='u')
	//  dcCost[index] = fabs(value1)/atof(argv[3]);
	//else
	//  dcCost[index] = fabs(value1)*atof(argv[3]);
	//fprintf(to,"%d %lf\n",index,dcCost[index]);
	//cout << index << " " << dcCost[index] << endl;
  }
  //fclose(to);
  fclose(from);

  int counter=0, maxErrorNode=0;
  double error=0, maxError=0;
  double gtlErrorAtMaxErrorNode=0;
  double dcAnaErrorAtMaxErrorNode=0;

  double maxPathLenth=0, avgPathLength=0;

  for(int i=0;i<nodes;i++)
  {
	if(i==source) continue;

	error = fabs(gtlCost[i]-dcCost[i]);
	if(error<1e-1)
	  counter++;
	else if(error > maxError)
	{	
	  maxError = error;
	  maxErrorNode = i;
	  gtlErrorAtMaxErrorNode = gtlCost[i];
	  dcAnaErrorAtMaxErrorNode = dcCost[i];
	}

	if(dcCost[i]>maxPathLenth)
	  maxPathLenth = dcCost[i];

	avgPathLength += dcCost[i];
  }		

  cout << "maxPathLenth " << maxPathLenth << " avgPathLength " 
	<< avgPathLength/nodes << endl;
  cout << "Cost matched on " << counter << " nodes." << endl;
  if(maxError!=0)
	cout << "maxError " << maxError << " at node " << maxErrorNode << " % maxError = " 
	  << (maxError/gtlErrorAtMaxErrorNode)*100 << endl;
  delete [] gtlCost;
  delete [] dcCost;

  exit(0);
}
