#include "global.h"
#define FTREE '$'
extern double Gval;
extern double Is;
extern double Vt;
#ifdef MCF 
void GraphOfNetwork::convertFlowProblemToCircuit(char*
circuitName,double scaleParameter)
{
  char tempStr[80];
  int sourceNode=0,sinkNode=0;
  FILE *from; 
  from=fopen(circuitName,"r+");
  if(from == NULL)
  {
	cout<<" *********Error*********" <<endl;
	cout<<" Flow Circuit File Not Found " <<endl;
	exit(0);
  }
  int i=0; 
  int nodeCost,nodeNumber,psuedoNode=0,capacity=0,cost=0;
  double branchValue;
  int flowSource=0,flowSink=0,mainCurrent=0;
  double MAXcost=0.0,MAXcapacity=0.0; 
  while (fgets(tempStr, 80, from) != NULL)
  {
      switch(tempStr[0]) 
	{
	case 'p':
	  sscanf(tempStr,"p min %d %d %d",&_Nodes,&_Edges,&_SimplifiedEdges);
	  psuedoNode= _Nodes; 
	  nodePtrList = (node*) calloc(_Nodes+2*_Edges-2*_SimplifiedEdges,sizeof(node));
	  edgePtrList = (edge*) calloc (_Edges*6+1-5*_SimplifiedEdges,sizeof(edge));
	  break;
	case 'n':
	  sscanf(tempStr,"n %d %d",&nodeNumber,&nodeCost);
 	  --nodeNumber;
	 
	  if(nodeCost > 0)  {flowSource = nodeNumber;mainCurrent=nodeCost;}
	  else if (nodeCost < 0) flowSink = nodeNumber; 
	  break;
	case 'a':
	  if(mainCurrent == 0 )
	  {
	   cout << " Error in file or Min Cost flow solution is all zero " << endl; 
	   cout << " Exiting Abnormally !!!!!!!!!!!  " << endl;
	   exit(1); 
	  }
	  sscanf(tempStr,"a %d %d %*d %d %d",&sourceNode,&sinkNode,&capacity,&cost);
	  if(capacity > mainCurrent)
		capacity=mainCurrent;
	  scalecapacity += capacity; 
	  scalecost += cost; 
    	  if(MAXcapacity < capacity) MAXcapacity = capacity; 
          if(MAXcost < cost) MAXcost = cost;
	  --sourceNode;--sinkNode;

	  if(nodePtrList[sourceNode] == NULL) nodePtrList[sourceNode] = new Node(sourceNode);
	  if(nodePtrList[sinkNode] == NULL) nodePtrList[sinkNode] = new Node(sinkNode);
	  if(nodePtrList[psuedoNode] == NULL) nodePtrList[psuedoNode] = new Node(psuedoNode);
	  if(nodePtrList[psuedoNode+1] == NULL) nodePtrList[psuedoNode+1] = new Node(psuedoNode+1);
	  
	  addEdge(cost,VoltageSource,nodePtrList[psuedoNode],nodePtrList[sinkNode],i);
	  addDiodeEdge(nodePtrList[sourceNode],nodePtrList[psuedoNode+1],i);
	  addDiodeEdge(nodePtrList[psuedoNode],nodePtrList[psuedoNode+1],i);
	  addEdge(capacity,CurrentSource,nodePtrList[psuedoNode+1],nodePtrList[psuedoNode],i);
	  ++++psuedoNode;
	  break;
        case 'I' :
	  cost=0;
	  sscanf(tempStr,"I %d %d %lf %*d %d",&sourceNode,&sinkNode,&branchValue,&cost);
	  --sourceNode;--sinkNode;

	  if(nodePtrList[sourceNode] == NULL) nodePtrList[sourceNode] = new Node(sourceNode);
	  if(nodePtrList[sinkNode] == NULL) nodePtrList[sinkNode] = new Node(sinkNode);
	  addEdge(branchValue,CurrentSource,nodePtrList[sourceNode],nodePtrList[sinkNode],i);
	  scalecapacity += branchValue; 
          if(MAXcapacity < branchValue) MAXcapacity = branchValue; 
          flowCost+=branchValue*double(cost);
	  break;	
        case 'V' :
	  sscanf(tempStr,"V %d %d %*d %lf",&sourceNode,&sinkNode,&branchValue);
	  --sourceNode;--sinkNode;
	  if(nodePtrList[sourceNode] == NULL) nodePtrList[sourceNode] = new Node(sourceNode);
	  if(nodePtrList[sinkNode] == NULL) nodePtrList[sinkNode] = new Node(sinkNode);
	  addEdge(branchValue,VoltageSource,nodePtrList[sourceNode],nodePtrList[sinkNode],i);
	  branchValue*=10000;
          scalecost += branchValue; 
          if(MAXcost < branchValue ) MAXcost = branchValue ; 
          ++_VoltageSource;
 	  break;	
	case 'c' : break; // comment 
	default : cout <<"File doesn't looks to be in DIMACS format " << endl;exit(0);  
      }
  }
         // How to decide on branchValue of Source-SInk current source ? 
  addEdge(mainCurrent,CurrentSource,nodePtrList[flowSink],nodePtrList[flowSource],i);
  if(MAXcapacity < mainCurrent) MAXcapacity = mainCurrent; 
  fclose(from);

  cout<<"FlowGraph : Nodes are " << _Nodes << " and Edges are " << _Edges  << endl ; 
  _Nodes += (_Edges+_Edges-2*_SimplifiedEdges); 
  _VoltageSource +=(_Edges-_SimplifiedEdges); 
  _Diode = (_Edges+_Edges-2*_SimplifiedEdges);
  _Edges = 6*_Edges + 1-5*_SimplifiedEdges;
  edge e;
 
  scalecost/= _Edges;         //why averaging technique is used? & why averaging is done using circuit edges?   
  scalecapacity /= _Edges;
  cout<<"Max capacity: "<<MAXcapacity<<" Max Cost: "<<MAXcost<<endl;
  if(scaleParameter == 0) {scalecapacity = 1 ; scalecost = 1; }
  else  
  {
	scalecapacity /=scaleParameter; 
	scalecost /=scaleParameter;
	if(scalecost<1)
                scalecost=1;
        if(scalecapacity<1)
                scalecapacity=1;
        MAXcapacity/=scalecapacity;
        MAXcost/=scalecost;
/*        while(MAXcost>3000){
                scalecost*=2;
                MAXcost/=2;
        }*/

        MAXcapacity/=scalecapacity;
        MAXcost/=scalecost;

	cout<< "modified scale cost: "<<scalecost<<" scale capacity: "<< scalecapacity<<endl; 
	double max_capacity=0.0,max_cost=0.0,min_capacity=1.0;
        for(int i=0;i<_Edges;++i)
	{
	  e = edgePtrList[i];
	  if(e->isEdgeType(VoltageSource))
	    	e->Voltage /= scalecost ; 
	  if(e->isEdgeType(Diode)) ++i; 
	  if(e->isEdgeType(CurrentSource)){ 
		e->EdgeValue /= scalecapacity;
          if(max_capacity<e->EdgeValue)
		max_capacity=e->EdgeValue;
          if(min_capacity>e->EdgeValue && e->EdgeValue)
		min_capacity=e->EdgeValue;
          }
	  if(max_cost<e->Voltage)
		max_cost=e->Voltage; 
	}
	cout<<"Max capacity: "<<max_capacity<<" Max Cost: "<<max_cost<<" Min Capacity: "<<min_capacity<<endl;
  }
  firstNode = nodePtrList[0] ; 
  cout<<"Equivalent Circuit : Nodes are " << _Nodes << " and Edges are " << _Edges << endl ; 
}
#endif

void GraphOfNetwork::addEdge(double Value,char Type,node Source,node Sink,int& i)
{
  edgePtrList[i] = new Edge(Value,Type,Source,Sink);
  Source->addEdgeList(edgePtrList[i]);
  Sink->addEdgeList(edgePtrList[i]);
  ++i;
}

void GraphOfNetwork::addDiodeEdge(node Source,node Sink,int& i)
{
  // a diode is a Resistance Diode and current source CurrentSource in parallel 
  edgePtrList[i] = new Edge(Gval,Diode,Source,Sink);
  Source->addEdgeList(edgePtrList[i]);
  Sink->addEdgeList(edgePtrList[i]);
  ++i; 
  edgePtrList[i] = new Edge(0,CurrentSource,Source,Sink);
  Source->addEdgeList(edgePtrList[i]);
  Sink->addEdgeList(edgePtrList[i]);
  ++i;
}

#ifdef DCANA 

void GraphOfNetwork::convertCircuitIntoGraph(char* circuitName)
{
  char edgeType,tempStr[80];
  int sourceNode=0,sinkNode=0;
  double branchValue=0;

  FILE* from;
  from=fopen(circuitName,"r+");
  if(from == NULL) 
  {
	cout<<" *********Error*********" <<endl;
	cout<<" Circuit File Not Found " <<endl;
	exit(0);
  }

  while (fgets(tempStr, 80, from) != NULL)
  {
	if(tempStr[0]=='.')
	  break;
	if(tempStr[0]==Diode)
	  ++_Diode;
	++_Edges;
	sscanf(tempStr, "%*s %d %d %*s", &sourceNode, &sinkNode);
	if(sourceNode> _Nodes) _Nodes=sourceNode;
	if(sinkNode >  _Nodes) _Nodes=sinkNode;
  }
  ++_Nodes;
  _Edges +=_Diode;
  nodePtrList = (node*) calloc(_Nodes,sizeof(node)); 
  edgePtrList = (edge*) calloc (_Edges,sizeof(edge));
  fclose(from);
  from=fopen(circuitName,"r+");
  int i=0;
  do
  {
	fscanf(from,"%c%*d %d %d",&edgeType,&sourceNode,&sinkNode);
	if(nodePtrList[sourceNode]==NULL) nodePtrList[sourceNode]=new Node(sourceNode);
	if(nodePtrList[sinkNode]==NULL)  nodePtrList[sinkNode]=new Node(sinkNode);
	switch(edgeType)
	{
	  case VoltageSource:
		++_VoltageSource;
	  case CurrentSource:
	  case Resistance:
		fscanf(from,"%lf\n",&branchValue);
		if(edgeType==Resistance)
		{
		  if(branchValue < 1e-6) 
		  {
			++_VoltageSource;
			edgeType=VoltageSource;
		  }
		  else
			branchValue=1.0/branchValue;
		}
		addEdge(branchValue,edgeType,nodePtrList[sourceNode],nodePtrList[sinkNode],i);
		break;
	  case Diode:
		fscanf(from,"%s\n",tempStr);
		if(strcmp(tempStr,"MOD1"))
		  addDiodeEdge(nodePtrList[sourceNode],nodePtrList[sinkNode],i);
		break;
	  case '.':
		fscanf(from,"%s",tempStr);
		if(strcmp(tempStr,"end")==0)
		  break;
	  default : 
		cout << "Error : Check the circuit : Only use RVID circuits" << endl;
		exit(1);
	}
  }
  while(edgeType!='.');
  fclose(from);
  cout <<" Total Nodes : " << _Nodes << " Total Edges : " << _Edges << endl;
  cout <<" Total Voltage Sources : " << _VoltageSource;
   _Diode==0?:cout<<" Diodes : "<< _Diode;
  firstNode = nodePtrList[0] ; 
  cout<<endl;
}
#endif 

double GraphOfNetwork::printSolution(char* cktfile)
{
  char solution[80];
  edge e; 
  double totalPower=0,Gval; 
  int count=0;
  
  strcpy(solution,cktfile);
  strcat(solution,".sol");
  FILE *mcf_sol= fopen (solution, "w+");
  fprintf(mcf_sol,"      N         Voltage            Current             \n");
  fprintf(mcf_sol,"      -------------------------------------------------\n");
  count=0;
  double diodeI;  
  for(int i=0;i<_Edges;++i)
  {
	e=edgePtrList[i];
	if(e->isEdgeType(Diode)) 
          e->EdgeValue += edgePtrList[++i]->EdgeValue;
        totalPower+= e->Voltage*e->EdgeValue;
        fprintf (mcf_sol, "%7d %15lf %0.12lf\n",++count,e->Voltage, e->EdgeValue);
  }
  fclose (mcf_sol);

  printf("Total Power is %lf\n",totalPower);
  printf("Solution written to file %s\n",solution);
  return totalPower ; 
}

#ifdef MCF
void GraphOfNetwork::scaling()
{
  edge e;	
  for(int i=0;i<_Edges;++i)
  {
	e=edgePtrList[i];
	e->Voltage *= scalecost;
        e->EdgeValue *= scalecapacity;
  }
}

void GraphOfNetwork::printFlowInfo(char* cktfile)
{
  int sourceNode=0,sinkNode=0,cost=0,capacity=0;
  double power=0;
  double Dpower=0,DualityGap=0.0;
  int count=0;
  edge e;
  char file[80];
  strcpy(file,cktfile);
  FILE *flow;
  if(!_SimplifiedEdges){
	FILE *problem;
  	char tempStr[80];
  	problem=fopen(file,"r");
  	strcat(file,".flow");
  	flow=fopen(file,"w+");
  	fprintf(flow,"    N   Source   Sink   Cost    Capacity   Flow          \n");
  	fprintf(flow,"      -------------------------------------------------\n");
	while(fgets(tempStr,80,problem)!=NULL)
           if(tempStr[0]=='a')
              break;
	forall_edges(e){
           sscanf(tempStr,"a %d %d %*d %d %d",&sourceNode,&sinkNode,&capacity,&cost);
           if(e->isEdgeType(VoltageSource)&& e->EdgeValue>0){
              power=e->Voltage*e->EdgeValue;
              flowCost+=power;
              fprintf (flow, "%5d %5d %5d %10d %10d %10d A \n",++count,sourceNode,sinkNode,cost,capacity,(int)round(e->EdgeValue));
           }
	   else if(e->isEdgeType(Diode)){
	   //   cout<<(e->EdgeValue+edgePtrList[i+1]->EdgeValue)/scalecapacity<<endl;
           //   Dpower=Vt*log((e->EdgeValue+edgePtrList[i+1]->EdgeValue)/(Is*scalecapacity)+1)*(e->EdgeValue+edgePtrList[i+1]->EdgeValue)/scalecapacity;
              Dpower=e->Voltage*e->EdgeValue+edgePtrList[i+1]->EdgeValue;
	      if(i%6==3)
  		DualityGap-=Dpower;
	      else
  		DualityGap+=Dpower;
           }
           if(e->isEdgeType(VoltageSource)){
	      //  cout<<"Edge Voltage: "<<edgePtrList[i]->Voltage+edgePtrList[i+1]->Voltage-edgePtrList[i+3]->Voltage<<endl;
           	fgets(tempStr,80,problem);
	   }
        }
     	printf("Min Flow Cost %lf\n",flowCost);
  //   	printf("Duality Gap %lf\n",DualityGap);
        fclose(flow);
	fclose(problem);
  }
  else{
	fgedge e1; 
  	int counter=0;
  	int* Node_current = (int*) calloc(_Nodes,sizeof(int));
	strcat(file,".flow");
        flow=fopen(file,"w+");
        forall_edges(e)
        	if(e->isEdgeType(VoltageSource)&& e->EdgeValue>0){
            		power=e->Voltage*e->EdgeValue;
            		flowCost+=power;
         	}
     	printf("Min Flow Cost without rounding %lf\n",flowCost);
     	flowCorrection(cktfile,Node_current);
     	flowCost=0;
        count=0;
  	fprintf(flow,"    N   Source   Sink   Cost    Capacity   Flow          \n");
  	fprintf(flow,"      -------------------------------------------------\n");
  	forall_fgedges(e1){
        	if(e1->edgeCovered!=false && e1->edgeCovered!=FTREE){
          		if(e1->EdgeValue!=0 && e1->Voltage!=0){
             			fprintf(flow, "%7d %d %d %15lf V %15lf A %c \n",++count,e1->Source->nodeNumber+1,e1->Sink->nodeNumber+1,e1->Voltage,e1->EdgeValue,e1->edgeCovered);
             			power=e1->Voltage*e1->EdgeValue;
             			flowCost+=power;
          		}
        	}
        	else
          		++counter;
    	}
  	if(counter==0){
        	fprintf(flow, "Min Cost Flow %lf\n",flowCost);
  		printf("Min Flow Cost %lf\n",flowCost);
  	}
  	else{
  		printf("Partial Min Cost Flow %lf\n",flowCost);
     		counter=0;
     		_SimplifiedEdges=-1;
     		int _nodes=0;
     		for(int i=0;e1=fgEdgePtrList[i],i<_Edges;++i)
        		if(e1->edgeCovered==FTREE)
           			++_nodes;
        		else if(e1->edgeCovered==false)
           			++counter;
     		for(int i=0;i<_Nodes;++i)
        		if(Node_current[i]!=0)
           			++_SimplifiedEdges;
     		counter+=_SimplifiedEdges+_nodes;
     		_nodes+=1;
     		strcpy(file,cktfile);
     		FILE *RFG=fopen(file,"w+");
     		fprintf(RFG,"c Reduced MinCostFlow problem\n");
     		fprintf(RFG,"p min %d %d %d\n",_nodes,counter,_SimplifiedEdges);
     		fprintf(RFG,"m %lf\n",flowCost);
     		int temp_node=0;
     		for(int i=0;i<_Nodes;++i)
        		if(Node_current[i]!=0){
          			if(temp_node==0){
                			temp_node=i+1;
                			continue;
          			}
          			fprintf(RFG,"I %d %d %d %d 0\n",i+1,temp_node,Node_current[i],Node_current[i]);
        		}
     		for(int i=0;e1=fgEdgePtrList[i],i<_Edges;++i)
        		if(e1->edgeCovered==false || e1->edgeCovered==FTREE)
           			fprintf(RFG,"a %d %d 0 %d %d\n",e1->Source->nodeNumber+1,e1->Sink->nodeNumber+1,e1->Capacity,(int)e1->Voltage);
     			if(temp_node==0){
        			fprintf(flow, "Min Flow Cost %lf\n",flowCost);
				cout<<"No Further Analysis required"<<endl;
     		}
     		fclose(flow);
     		fclose(RFG);
  	}
  	free(Node_current);
  }
}
#endif

