#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <iostream>
#include <fstream>

using namespace std;

int main(int argc,char** argv)
{
  clock_t time1= clock();
  char edgeType,tempStr[80];
  int edgeNumber=0,sourceNode=0,sinkNode=0;
  double branchValue=0;
	
  if(argc!=8)
  {
  	cout << "Format is \"scaleGen cktFile shpGph v-scale-para up/down(u/d) a/m/n " 
	     <<	"i-scale-para up/down(u/d)\"." << endl; exit(1);
  }

  cout << argv[1] << " " << argv[2] << " " << argv[3] << " " << argv[4] << " " << argv[5] << " " << argv[6] << " " << argv[7] << endl;
  
  int nodes=0,edges=0;
  double value=0;
  double avgCost=0, maxCost=0;
  FILE* from=NULL;
  
  if(argv[5][0]=='a' || argv[5][0]=='m')
  {
    from=fopen(argv[2],"r");  
  	fscanf(from,"%d%d\n",&nodes,&edges);
	for(int i=1;i<=edges;i++)
	{
	  fscanf(from,"%d%d%d%lf\n",&edgeNumber,&sourceNode,&sinkNode,&value);
	  //cout << edgeNumber << " " << sourceNode << " " << sinkNode << " " << value << endl;
	  if(maxCost < value)
	  	maxCost = value;
	  avgCost += fabs(value);
	}
	avgCost /= edges;
  }
  cout << "maxCost " << maxCost << " avgCost " << avgCost << endl;

  double vScaleFactor;

  if(argv[5][0]=='a')
	vScaleFactor = avgCost*atof(argv[3]);
  else if(argv[5][0]=='m')
	vScaleFactor = maxCost*atof(argv[3]);
  else
	vScaleFactor = atof(argv[3]);

  cout << "vScaleFactor " << vScaleFactor << endl;

  from = fopen(argv[1],"r+");
  if(from == NULL) 
  {
	cout<<" *********Error*********" <<endl;
	cout<<" Circuit File Not Found " <<endl;
	exit(0);
  }

  FILE *to=fopen("scCkt","w+");

  do
  {
	fscanf(from,"%c",&edgeType);
	switch(edgeType)
	{
	  case 'D':
		fscanf(from,"%d %d %d %s\n",&edgeNumber,&sourceNode,&sinkNode,tempStr);
		//printf("D%d %d %d %s\n",edgeNumber,sourceNode,sinkNode,tempStr);
		fprintf(to,"D%d %d %d %s\n",edgeNumber,sourceNode,sinkNode,tempStr);
		break;
	  case 'I':
		fscanf(from,"%d %d %d %lf\n",&edgeNumber,&sourceNode,&sinkNode,&branchValue);

		if(argv[7][0]=='u')
		  fprintf(to,"I%d %d %d %lf\n",edgeNumber,sourceNode,sinkNode,branchValue*atoi(argv[6]));
		else if(argv[7][0]=='d')
		  fprintf(to,"I%d %d %d %lf\n",edgeNumber,sourceNode,sinkNode,branchValue/atoi(argv[6]));

		break;
	  case 'R':
		break;
	  case 'V':
		fscanf(from,"%d %d %d %lf\n",&edgeNumber,&sourceNode,&sinkNode,&branchValue);
		//printf("V%d %d %d %lf\n",edgeNumber,sourceNode,sinkNode,branchValue*atoi(argv[2]));

		if(argv[4][0]=='u')
		  fprintf(to,"V%d %d %d %lf\n",edgeNumber,sourceNode,sinkNode,branchValue*vScaleFactor);
		else if(argv[4][0]=='d')
		  fprintf(to,"V%d %d %d %lf\n",edgeNumber,sourceNode,sinkNode,branchValue/vScaleFactor);

		break;
	  case '.':
		fscanf(from,"%s",tempStr);
		fprintf(to,".%s\n",tempStr);
		//printf(".%s\n",tempStr);
		if(strcmp(tempStr,"end")==0)
		  break;
	  default : 
		cout << "Error : Check the circuit : Only use RVID circuits" << endl;
		exit(1);
	}
  }
  while(edgeType!='.');

  FILE *fpScaleFactor = fopen(".scaleFactorInfo","w");
  fprintf(fpScaleFactor,"%lf\n",vScaleFactor);
  fclose(fpScaleFactor);


  fclose(to);
  fclose(from);
}
